SLASH_AUTOVENDORTOGGLEJUNK1 = '/junk'
SLASH_AUTOVENDORTOGGLENOTJUNK1 = '/notjunk'
SLASH_AUTOVENDORJUNKLIST1 = '/junklist'
SLASH_AUTOVENDORNOTJUNKLIST1 = '/notjunklist'

function SlashCmdList.AUTOVENDORTOGGLEJUNK(msg, editbox)
	if msg then
		AutoVendor_InitVars()
		local itemId = tonumber(strmatch(msg, "item:(%d+)"))
		local itemName = select(1, GetItemInfo(msg))
		if itemId and itemName then
			AutoVendor_Toggle(AutoVendor['JunkList'], 'junk list', itemId, itemName)
		else
			if msg and AutoVendor_Remove(AutoVendor['JunkList'], msg) then
				print('Removed '..msg..' from junk list.')
			else
				print('No item (link) supplied!')
			end
		end
	else
		print('No item link supplied!')
	end
end
function SlashCmdList.AUTOVENDORTOGGLENOTJUNK(msg, editbox)
	if msg then
		AutoVendor_InitVars()
		local itemId = tonumber(strmatch(msg, "item:(%d+)"))
		local itemName = select(1, GetItemInfo(msg))
		if itemId and itemName then
			AutoVendor_Toggle(AutoVendor['NotJunkList'], 'not junk list', itemId, itemName)
		else
			if msg and AutoVendor_Remove(AutoVendor['NotJunkList'], msg) then
				print('Removed '..msg..' from not junk list.')
			else
				print('No item (link) supplied!')
			end
		end
	else
		print('No item (link) supplied!')
	end
end

function SlashCmdList.AUTOVENDORJUNKLIST(msg, editbox)
	AutoVendor_InitVars()
	print('Items in the junk list:')
	AutoVendor_FormatList(AutoVendor['JunkList'])
end

function SlashCmdList.AUTOVENDORNOTJUNKLIST(msg, editbox)
	AutoVendor_InitVars()
	print('Items in the not junk list:')
	AutoVendor_FormatList(AutoVendor['NotJunkList'])
end

function AutoVendor_FormatList(list)
	local tmpList = {}
	for _,v in pairs(list) do
		table.insert(tmpList, v)
	end
	table.sort(tmpList)
	local tmpString = ''
	for _,v in pairs(tmpList) do
		if #tmpString == 0 then
			tmpString = v
		else
			tmpString = tmpString .. ', ' .. v
		end
		if #tmpString > 50 then
			print(tmpString)
			tmpString = ''
		end
	end
	if #tmpString ~= 0 then
		print(tmpString)
	end
end

function AutoVendor_Toggle(list, listName, itemId, itemName)
	if list[itemId] then
		list[itemId] = nil
		print('Removed '..itemName..' from '..listName..'.')
	else
		table.insert(list, itemId, itemName)
		print('Added '..itemName..' to '..listName..'.')
	end
end

local function OnEvent()
	AutoVendor_InitVars()
	for bag=0,4 do
		for slot=0,GetContainerNumSlots(bag) do
			local link = GetContainerItemLink(bag, slot)
			if link then
				local itemId = tonumber(strmatch(link, "item:(%d+)"))
				if (select(3, GetItemInfo(link)) == 0 or AutoVendor['JunkList'][itemId]) and not AutoVendor['NotJunkList'][itemId] and itemId ~= 6196 then
					ShowMerchantSellCursor(1)
					UseContainerItem(bag, slot)
				end
			end
		end
	end
end

function AutoVendor_Remove(list, item)
	found = false
	for k,v in pairs(list) do
		if string.lower(v) == string.lower(item) then
			list[k] = nil
			found = true
		end
	end
	return found
end

function AutoVendor_InitVars()
	if AutoVendor == nil or type(AutoVendor) ~= "table" then
		AutoVendor = {}
	end
	if AutoVendor['JunkList'] == nil or type(AutoVendor['JunkList']) ~= "table" then
		AutoVendor['JunkList'] = {}
	end
	if AutoVendor['NotJunkList'] == nil or type(AutoVendor['NotJunkList']) ~= "table" then
		AutoVendor['NotJunkList'] = {}
	end
	if not AutoVendor['SavedVariablesVersion'] then
		AutoVendor['SavedVariablesVersion'] = -1
	end
	if AutoVendor['SavedVariablesVersion'] < AUTOVENDOR_CURRENT_VERSION then
		for k,v in pairs(AUTOVENDOR_NOT_JUNK) do
			if k > AutoVendor['SavedVariablesVersion'] then
				for k2,v2 in pairs(v) do
					AutoVendor['NotJunkList'][k2] = v2
				end
			end
		end
	end
	
	AutoVendor['SavedVariablesVersion'] = AUTOVENDOR_CURRENT_VERSION
end

local f = CreateFrame("Frame")
f:RegisterEvent("MERCHANT_SHOW")
f:SetScript("OnEvent", OnEvent)

if MerchantFrame:IsVisible() then OnEvent() end


AUTOVENDOR_CURRENT_VERSION = 0.2;
AUTOVENDOR_NOT_JUNK = {
	[0.1] = {
		[1485] = "Pitchfork",
		[39202] = "Rusted Pitchfork",
		[3944] = "Twill Belt",
		[3945] = "Twill Boots",
		[3946] = "Twill Bracers",
		[3947] = "Twill Cloak",
		[8754] = "Twill Cover",
		[3948] = "Twill Gloves",
		[3949] = "Twill Pants",
		[3950] = "Twill Shoulderpads",
		[3951] = "Twill Vest",
	},
}